from dotenv import load_dotenv
from fastapi import FastAPI

from api.components.document import documents_routes
from api.components.user import users_routes
from api.components.table import tables_routes
from api.routes.auth import auth_routes

app = FastAPI()
app.include_router(auth_routes, prefix="/api")
app.include_router(documents_routes, prefix="/api")
app.include_router(users_routes, prefix="/api")
app.include_router(tables_routes, prefix="/api")
load_dotenv()
