#!/bin/sh

usage() {
    cat <<EOF
usage: ${0##*/} [command]
    -h          Print this help message.
    -a          Run API.
    -i          Install.
    -d          Run docker-compose.
EOF
    exit 1
}

RUN=
while getopts "hadic" OPTION; do
    case $OPTION in
    a) RUN=api ;;
    d) RUN=docker ;;
    i) RUN=install ;;
    c) RUN=configure;;
    *) usage ;;
    esac
done

if [ "$RUN" = 'install' ]; then
    poetry install
elif [ "$RUN" = 'api' ]; then
    poetry shell
    uvicorn api.api:app --host 0.0.0.0
elif [ "$RUN" = 'configure' ]; then
    poetry run configure
else
    [ ! -d postgres_data ] && mkdir postgres_data
    [ ! -d mongo_data ] && mkdir mongo_data
    [ ! -d elasticsearch_data ] && mkdir elasticsearch_data
    docker-compose up
fi
